routes/web.php
<?php

use App\Http\Controllers\ActivityLogController;
use App\Http\Controllers\AnnouncementController;
use App\Http\Controllers\Auth\LoginController;
use App\Http\Controllers\EmailController;
use App\Http\Controllers\FaqController;
use App\Http\Controllers\HolidayController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\InboxController;
use App\Http\Controllers\LogController;
use App\Http\Controllers\NotifyController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\Reference\SalaryGradeDetailsController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\GroupRoleController;
use App\Http\Controllers\SettingsController;
use App\Http\Controllers\StatisticsController;
use App\Http\Controllers\UserController;
use App\Http\Controllers\CaptchaController;
use App\Http\Controllers\Reference\AreaInterviewCentreController;
use App\Http\Controllers\Security\MenuController;
use App\Http\Controllers\Reference\StateController;
use App\Http\Controllers\Reference\ReligionController;
use App\Http\Controllers\Reference\MaritalStatusController;
use App\Http\Controllers\Reference\DepartmentMinistryController;
use App\Http\Controllers\Reference\EligibilityController;
use App\Http\Controllers\Reference\SkimController;
use App\Http\Controllers\Reference\InstitutionController;
use App\Http\Controllers\Reference\SpecializationController;
use App\Http\Controllers\Reference\QualificationController;
use App\Http\Controllers\Reference\RaceController;
use App\Http\Controllers\Reference\GenderController;
use App\Http\Controllers\Reference\InterviewCentreController;
use App\Http\Controllers\Reference\JobController;
use App\Http\Controllers\Reference\LanguageController;
use App\Http\Controllers\Reference\LevelJKKController;
use App\Http\Controllers\Reference\MatriculationController;
use App\Http\Controllers\Reference\MatriculationCourseController;
use App\Http\Controllers\Reference\MatriculationSubjectController;
use App\Http\Controllers\Reference\PenaltyController;
use App\Http\Controllers\Reference\PositionLevelController;
use App\Http\Controllers\Reference\RankController;
use App\Http\Controllers\Reference\SalaryGradeController;
use App\Http\Controllers\Reference\SubjectController;
use App\Http\Controllers\Reference\TalentController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
 */

// Route::get('test-ts', [App\Http\Controllers\TestController::class, 'updateTimesheet']);
// Route::get('test-chart', [FinanceController::class, 'manpowerChart']);

Route::get('/', function () {
    return redirect()->route('login');
});

Route::get('emptyresponse', function () {
    return response()->json(['title' => ' ']);
})->name('emptyResponse');

Auth::routes();
Route::controller(LoginController::class)->group(function () {
    // Syntax
    // Route::get('name of link', 'name of function')

    Route::get('logout', 'logout')->name('logout.get');

    Route::prefix('auth/google')->group(function () {
        Route::get('/', 'redirectToProvider')->name('google.redirect');
        Route::get('auth/google/callback', 'handleProviderCallback')->name('google.callback');
    });

});

Route::get('reload-captcha', [CaptchaController::class, 'reloadCaptcha'])->name('reload.captcha');

Route::get('home', [HomeController::class, 'index'])->name('home');

// locale Route
Route::get('lang/{locale}', [LanguageController::class, 'swap']);

Route::get('inbox', [InboxController::class, 'index'])->name('inbox');

Route::controller(StatisticsController::class)->group(function () {
    Route::get('statistics', 'index')->name('statistics');
    Route::post('statistics', 'generateChart')->name('statistics.generate');
});

Route::prefix('profile')->group(function () {
    Route::get('view', [ProfileController::class, 'view'])->name('profile-view');
    Route::post('update', [ProfileController::class, 'update'])->name('profile-update');
});

Route::prefix('admin')->group(function () {
    Route::resource('user', UserController::class);
    Route::resource('role', RoleController::class);

    Route::get('internalUser',[UserController::class,'index'])->name('admin.internalUser');
    Route::get('externalUser',[UserController::class,'index'])->name('admin.externalUser');
    Route::get('getUser/{userId}', [UserController::class,'getUser'])->name('user.getUser');
    Route::post('update-password', [UserController::class,'updatePassword'])->name('updatePassword');

    Route::get('edit/{roleId}', [RoleController::class,'getRole'])->name('role.kemaskini');
    Route::get('edittingRole/{roleId}', [RoleController::class, 'getRole'])->name('role.editting');
    Route::post('delete-role/{roleId}', [RoleController::class,'deleteRole'])->name('roles.delete');
    Route::get('view-role/{roleId}', [RoleController::class,'viewForm'])->name('roles.view');

    Route::post('getMenu', [RoleController::class, 'getMenu'])->name('role.getMenu');
    Route::post('getNextMenu', [RoleController::class, 'getNextMenu'])->name('role.getNextMenu');
    Route::get('editRole/{roleId}', [RoleController::class, 'editRole'])->name('role.editRole');
    Route::post('updateRole/{roleId}', [RoleController::class, 'updateRole'])->name('role.updateRole');

    Route::prefix('group_role')->group(function () {
        Route::get('/', [GroupRoleController::class, 'index'])->name('admin.group-role');

        Route::get('edit/{roleId}', [GroupRoleController::class, 'edit'])->name('admin.group-role.edit');
        Route::get('getRole/{roleId}', [GroupRoleController::class, 'getRole'])->name('admin.group-role.getRole');
    });

    Route::prefix('settings')->group(function () {
        Route::get('/', [SettingsController::class, 'index'])->name('settings.index');
        Route::post('/', [SettingsController::class, 'update'])->name('admin.settings');
        Route::prefix('save')->group(function () {
            Route::post('/', [SettingsController::class, 'settings_save'])->name('admin.settings.save');
        });
        Route::prefix('checkemail')->group(function () {
            Route::post('/', [SettingsController::class, 'checkEmail'])->name('admin.settings.checkemail');
        });
        Route::get('picture/{filename}', [SettingsController::class, 'picture'])->name('settings.picture');

        Route::prefix('log')->group(function () {
            Route::get('index', [ActivityLogController::class, 'index'])->name('admin-log-index');
            Route::get('view/{logID}', [ActivityLogController::class, 'view'])->name('admin-log-view');
        });

    });

    Route::prefix('reference')->group(function () {
        Route::prefix('state')->group(function () {
            Route::get('/', [StateController::class, 'index'])->name('admin.reference.state');
            Route::post('create', [StateController::class, 'store'])->name('admin.reference.state.store');
            Route::get('edit/{stateId}', [StateController::class, 'edit'])->name('admin.reference.state.edit');
            Route::post('update/{stateId}', [StateController::class, 'update'])->name('admin.reference.state.update');
            Route::post('toggleActive/{stateId}', [StateController::class, 'toggleActive'])->name('admin.reference.state.toggleActive');

        });

        Route::prefix('religion')->group(function () {
            Route::get('/', [ReligionController::class, 'index'])->name('admin.reference.religion');
            Route::post('create', [ReligionController::class, 'store'])->name('admin.reference.religion.store');
            Route::get('edit/{religionId}', [ReligionController::class, 'edit'])->name('admin.reference.religion.edit');
            Route::post('update/{religionId}', [ReligionController::class, 'update'])->name('admin.reference.religion.update');
            Route::post('toggleActive/{religionId}', [ReligionController::class, 'toggleActive'])->name('admin.reference.religion.toggleActive');
        });

        Route::prefix('marital_status')->group(function () {
            Route::get('/', [MaritalStatusController::class, 'index'])->name('admin.reference.marital-status');
            Route::post('create', [MaritalStatusController::class, 'store'])->name('admin.reference.marital-status.store');
            Route::get('edit/{maritalStatusId}', [MaritalStatusController::class, 'edit'])->name('admin.reference.marital-status.edit');
            Route::post('update/{maritalStatusId}', [MaritalStatusController::class, 'update'])->name('admin.reference.marital-status.update');
            Route::post('toggleActive/{maritalStatusId}', [MaritalStatusController::class, 'toggleActive'])->name('admin.reference.marital-status.toggleActive');

        });

        Route::prefix('department_ministry')->group(function () {
            Route::get('/', [DepartmentMinistryController::class, 'index'])->name('admin.reference.department-ministry');
            Route::post('create', [DepartmentMinistryController::class, 'store'])->name('admin.reference.department-ministry.store');
            Route::get('edit/{departmentMinistryId}', [DepartmentMinistryController::class, 'edit'])->name('admin.reference.department-ministry.edit');
            Route::post('update/{departmentMinistryId}', [DepartmentMinistryController::class, 'update'])->name('admin.reference.department-ministry.update');
            Route::post('toggleActive/{departmentMinistryId}', [DepartmentMinistryController::class, 'toggleActive'])->name('admin.reference.department-ministry.toggleActive');
        });

        Route::prefix('skim')->group(function () {

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;
use Spatie\Activitylog\LogOptions;
use Spatie\Activitylog\Traits\LogsActivity;
use Spatie\Permission\Traits\HasRoles;
use Mail;
use App\Mail\Auth\ResetPasswordUser;

class User extends Authenticatable
{
    //use HasApiTokens, HasFactory, Notifiable, HasRoles, LogsActivity;
    use HasApiTokens, HasFactory, Notifiable, HasRoles;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'no_ic',
        'phone_number',
        'email',
        'password',
        'ref_department_ministry_code',
        'ref_skim_code',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    // public function getActivitylogOptions(): LogOptions
    // {
    //     return LogOptions::defaults()->logOnly(['*'])->logOnlyDirty();
    // }

    public function getRolesDisplay()
    {

        $roles = auth()->user()->roles()->pluck('display_name')->toArray();
        $display = '';

        foreach($roles as $role => $text){
            $display .= $text;
            if($role !== array_key_last($roles)){
                $display .= ',';
            }
        }

        return $display;
    }

    public function sendPasswordResetNotification($token)
    {
        Mail::to($this->email)->send(new ResetPasswordUser($token, $this->email));
    }

    public function roles()
    {
        return $this->belongsToMany('App\Models\Role', 'user_has_roles', 'user_id', 'role_id');
    }

    public function department_ministry()
    {
        return $this->belongsTo('App\Models\Reference\DepartmentMinistry', 'ref_department_ministry_code', 'kod');
    }

    public function skim()
    {
        return $this->belongsTo('App\Models\Reference\Skim', 'ref_skim_code', 'code');
    }
}

resources/views/admin/user/create.blade.php
@extends('layouts.app')

@section('header')
    @if($type == "internal")
        {{__('msg.userinternalcreate')}}
    @else
        {{__('msg.userexternalcreate')}}
    @endif
@endsection

@section('breadcrumb')
    <li class="breadcrumb-item"><a href="{{route('home')}}">{{__('msg.home')}}</a></li>
    @if($type == "internal")
        <li class="breadcrumb-item"><a href="{{ route('user.index',["type" => $type]) }}">{{__('msg.userinternalindex')}}</a>
        <li class="breadcrumb-item"><a>{{__('msg.userinternalcreate')}}</a>
    @else
        <li class="breadcrumb-item"><a href="{{ route('user.index',["type" => $type]) }}">{{__('msg.userexternalindex')}}</a>
        <li class="breadcrumb-item"><a>{{__('msg.userexternalcreate')}}</a>
    @endif
@endsection

@section('content')
<div class="row">
    <div class="col-12">

        <div class="card px-2">
            <div class="card-header">
                <h3 class="card-title">
                    @if($type == "internal")
                        {{__('msg.userinternalcreate')}}
                    @else
                        {{__('msg.userexternalcreate')}}
                    @endif
                </h3>
            </div>
            <div class="card-body">
                <form action="{{ route('user.store') }}" method="POST" class="form-horizontal" autocomplete="off">
                    @csrf
                    <div class="form-group row">
                        <label for="inputName" class="col-sm-2 col-form-label">Name</label>
                        <div class="col-sm-10">
                            <input type="text" name="name" class="form-control" id="inputName" placeholder="Name" required>
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="inputEmail" class="col-sm-2 col-form-label">Email</label>
                        <div class="col-sm-10">
                            <input type="text" name="email" class="form-control" id="inputEmail" placeholder="Email" required>
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="inputPassword" class="col-sm-2 col-form-label">Password</label>
                        <div class="col-sm-10">
                            <input type="password" name="password" class="form-control" id="inputPassword" placeholder="Password" required>
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="inputIsActive" class="col-sm-2 col-form-label">Is Active</label>
                        <div class="col-sm-10">
                            <select name="is_active" class="form-control" id="inputIsActive" required>
                                <option value=""></option>
                                <option value="1"> Active </option>
                                <option value="0"> Inactive </option>
                            </select>
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="inputRole" class="col-sm-2 col-form-label">Roles</label>
                        @foreach($roles as $role)
                        <div class="col-sm-2">
                            <div class="custom-control custom-checkbox">
                                <input class="custom-control-input" name="roles[]" value="{{ $role->name }}" type="checkbox" id="roleCB_{{ $role->id }}" />
                                <label for="roleCB_{{ $role->id }}" class="custom-control-label"> {{ $role->name }} </label>
                            </div>
                        </div>
                        @endforeach
                    </div>
                    <div class="form-group row">
                        <label for="inputIsClient" class="col-sm-2 col-form-label">Is Client?</label>
                        <div class="col-sm-2">
                            <div class="custom-control custom-radio">
                                <input class="custom-control-input" name="isClient" value="1" type="radio" id="isClient_1" />
                                <label for="isClient_1" class="custom-control-label"> Yes </label>
                            </div>
                        </div>
                        <div class="col-sm-2">
                            <div class="custom-control custom-radio">
                                <input class="custom-control-input" name="isClient" value="0" type="radio" id="isClient_2" />
                                <label for="isClient_2" class="custom-control-label"> No </label>
                            </div>
                        </div>
                    </div>
                    {{-- <div class="form-group row">
                        <label for="inputPermission" class="col-sm-2 col-form-label">Permissions</label>
                        <div class="col-sm-10 row">
                            @foreach($permissions as $permission)
                            <div class="col-sm-3 mb-1">
                                <div class="custom-control custom-checkbox">
                                    <input class="custom-control-input" name="permissions[]" value="{{ $permission->name }}" type="checkbox" id="permissionCB_{{ $permission->id }}" />
                                    <label for="permissionCB_{{ $permission->id }}" class="custom-control-label"> {{ $permission->name }} </label>
                                </div>
                            </div>
                            @endforeach
                        </div>
                    </div> --}}
                    <div class="card-footer">
                        <button type="submit" class="btn btn-success float-end">Submit</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/admin/user/edit.blade.php
@extends('layouts.app')

@section('header')
    @if($type == "internal")
        {{__('msg.userinternaledit')}}
    @else
        {{__('msg.userexternaledit')}}
    @endif
@endsection

@section('breadcrumb')
    <li class="breadcrumb-item"><a href="{{route('home')}}">{{__('msg.home')}}</a></li>
    @if($type == "internal")
    <li class="breadcrumb-item"><a href="{{ route('user.index',["type" => $type]) }}">{{__('msg.userinternalindex')}}</a>
    <li class="breadcrumb-item"><a>{{__('msg.userinternaledit')}}</a></li>
    @else
    <li class="breadcrumb-item"><a href="{{ route('user.index',["type" => $type]) }}">{{__('msg.userexternalindex')}}</a>
    <li class="breadcrumb-item"><a>{{__('msg.userexternaledit')}}</a></li>
    @endif
@endsection

@section('content')
<div class="row">
    <div class="col-12">

        <div class="card px-2">
            <div class="card-header">
                <h4 class="card-title">
                    @if($type == "internal")
                        {{__('msg.userinternalshow')}}
                    @else
                        {{__('msg.userexternalshow')}}
                    @endif
                </h4>
            </div>
            <div class="card-body">
                <form action="{{ route('user.update', $user) }}" method="POST" class="form-horizontal" autocomplete="off">
                    @csrf
                    <input type="hidden" name="_method" value="PUT"/>
                    <div class="form-group row">
                        <label for="inputName" class="col-sm-2 col-form-label">Name</label>
                        <div class="col-sm-10">
                            <input type="text" name="name" value="{{ $user->name }}" class="form-control" id="inputName" placeholder="Name" required>
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="inputEmail" class="col-sm-2 col-form-label">Email</label>
                        <div class="col-sm-10">
                            <input type="text" name="email" value="{{ $user->email }}" class="form-control" id="inputEmail" placeholder="Email" required>
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="inputPassword" class="col-sm-2 col-form-label">Password</label>
                        <div class="col-sm-10">
                            <input type="password" name="password" class="form-control" id="inputPassword" placeholder="Password">
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="inputIsActive" class="col-sm-2 col-form-label">Active</label>
                        <div class="col-sm-10">
                            <select name="is_active" class="form-control" id="inputIsActive" required>
                                <option value=""></option>
                                <option value="1" {{ $user->is_active == 1 ? 'selected' : '' }}> Active </option>
                                <option value="0" {{ $user->is_active == 0 ? 'selected' : '' }}> Inactive </option>
                            </select>
                        </div>
                    </div>

                    <div class="form-group row">
                        <label for="inputRole" class="col-sm-2 col-form-label">Roles</label>
                        @foreach($roles as $role)
                        <div class="col-sm-2">
                            <div class="custom-control custom-checkbox">
                                <input class="custom-control-input" name="roles[]" value="{{ $role->name }}" type="checkbox" id="roleCB_{{ $role->id }}" {{ $user->hasRole($role->name) ? 'checked' : '' }} />
                                <label for="roleCB_{{ $role->id }}" class="custom-control-label"> {{ $role->name }} </label>
                            </div>
                        </div>
                        @endforeach
                    </div>

                    <div class="form-group row">
                        <label for="inputIsClient" class="col-sm-2 col-form-label">Is Client?</label>
                        <div class="col-sm-2">
                            <div class="custom-control custom-radio">
                                <input class="custom-control-input" name="isClient" value="1" type="radio" id="isClient_1" />
                                <label for="isClient_1" class="custom-control-label"> Yes </label>
                            </div>
                        </div>
                        <div class="col-sm-2">
                            <div class="custom-control custom-radio">
                                <input class="custom-control-input" name="isClient" value="0" type="radio" id="isClient_2" />
                                <label for="isClient_2" class="custom-control-label"> No </label>
                            </div>
                        </div>
                    </div>

                    {{-- <div class="form-group row">
                        <label for="inputPermission" class="col-sm-2 col-form-label">Permissions</label>
                        <div class="col-sm-10 row">
                            @foreach($permissions as $permission)
                            <div class="col-sm-3 mb-1">
                                <div class="custom-control custom-checkbox">
                                    <input class="custom-control-input" name="permissions[]" value="{{ $permission->name }}" type="checkbox" id="permissionCB_{{ $permission->id }}" {{ $user->hasDirectPermission($permission->name) ? 'checked' : '' }} />
                                    <label for="permissionCB_{{ $permission->id }}" class="custom-control-label"> {{ $permission->name }} </label>
                                </div>
                            </div>
                            @endforeach
                        </div>
                    </div> --}}

                    <div class="card-footer">
                        <button type="submit" class="btn btn-success float-end">Submit</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>
@endsection